/*
    scconfig - dependency list of default tests
    Copyright (C) 2009  Tibor Palinkas

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

		Project page: http://repo.hu/projects/scconfig
		Contact via email: scconfig [at] igor2.repo.hu
*/

#include "dep.h"
#include "find.h"

void deps_default_init(void)
{
	dep_add("cc/cc",                    find_cc);
	dep_add("cc/cflags",                find_cc);
	dep_add("cc/ldflags",               find_cc);
	dep_add("cc/inline",                find_inline);
	dep_add("cc/varargmacro",           find_varargmacro);
	dep_add("cc/funcmacro",             find_funcmacro);
	dep_add("cc/constructor",           find_constructor);
	dep_add("cc/destructor",            find_destructor);
	dep_add("cc/rdynamic",              find_rdynamic);
	dep_add("cc/soname",                find_soname);
	dep_add("cc/fpic",                  find_fpic);
	dep_add("cc/ldflags_dynlib",        find_ldflags_dynlib);
	dep_add("libs/ldl",                 find_lib_ldl);
	dep_add("libs/lpthread",            find_lib_lpthread);
	dep_add("libs/lpthread-recursive",  find_lib_lpthread);
	dep_add("libs/printf_x",            find_printf_x);
	dep_add("libs/printf_ptrcast",      find_printf_ptrcast);
	dep_add("libs/snprintf",            find_snprintf);
	dep_add("libs/snprintf_safe",       find_snprintf);
	dep_add("libs/fs/realpath/presents",find_fs_realpath);
	dep_add("fstools/cp",               find_fstools_cp);
	dep_add("fstools/ln",               find_fstools_ln);
	dep_add("fstools/mv",               find_fstools_mv);
	dep_add("fstools/rm",               find_fstools_rm);
	dep_add("fstools/mkdir",            find_fstools_mkdir);
	dep_add("fstools/ar",               find_fstools_ar);
	dep_add("fstools/ranlib",           find_fstools_ranlib);
	dep_add("fstools/awk",              find_fstools_awk);
	dep_add("fstools/chmodx",           find_fstools_chmodx);
	dep_add("sys/name",                 find_uname);
	dep_add("sys/shell",                find_shell);
	dep_add("sys/shell_needs_quote",    find_shell);
	dep_add("sys/tmp",                  find_tmp);
	dep_add("sys/path_sep",             find_tmp);
	dep_add("sys/shell_eats_backslash", find_tmp);
	dep_add("sys/ext_exe",              find_uname);
	dep_add("sys/ext_dynlib",           find_uname);
	dep_add("sys/ext_stalib",           find_uname);
	dep_add("sys/ptrwidth",             find_sys_ptrwidth);
	dep_add("sys/byte_order",           find_sys_byte_order);
	dep_add("sys/size_t_broken",        find_sys_size_t_broken);

	dep_add("/internal/filelist/cmd",    find_filelist);
	dep_add("/internal/filelist/method", find_filelist);
}
