/*
array.h 
copyright 1991-96, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
*/

/*
This file was generated with the command

   notangle -R'"array.h"' array.w > array.h

Notangle is part of Norman Ramsey's noweb literate programming package
available from CTAN(ftp.shsu.edu).

It's easiest to read or modify this file by working with array.w.
*/

#ifndef ARRAY_H
#define ARRAY_H 1

#define AY_NULL         0
#define AY_INT          1
#define AY_STR          2
#define AY_SPLIT        4

#define NO_CREATE  0
#define CREATE     1

#define new_ARRAY()  ((ARRAY)memset(ZMALLOC(struct array),0,sizeof(struct array)))

CELL* PROTO(mawk_array_find, (mawk_state_t *,ARRAY,CELL*,int)) ;
void  PROTO(mawk_array_delete, (mawk_state_t *,ARRAY,CELL*)) ;
void  PROTO(mawk_array_load, (mawk_state_t *, ARRAY,int)) ;
void  PROTO(mawk_array_clear, (mawk_state_t *, ARRAY)) ;
STRING** PROTO(mawk_array_loop_vector, (mawk_state_t *,ARRAY,unsigned*)) ;
CELL* PROTO(mawk_array_cat, (mawk_state_t *,CELL*,int)) ;

#endif /* ARRAY_H */

