
/********************************************
field.h
copyright 1991, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/

/* $Log: field.h,v $
 * Revision 1.2  1995/06/18  19:42:16  mike
 * Remove some redundant declarations and add some prototypes
 *
 * Revision 1.1.1.1  1993/07/03  18:58:12  mike
 * move source to cvs
 *
 * Revision 5.2  1992/01/06  08:10:24  brennan
 * set_binmode() proto for MSDOS
 *
 * Revision 5.1  91/12/05  07:59:16  brennan
 * 1.1 pre-release
 * 
*/

/* field.h */


#ifndef  FIELD_H
#define  FIELD_H   1

void  PROTO( mawk_set_field0, (mawk_state_t *, char *, unsigned) ) ;
void  PROTO( mawk_split_field0, (mawk_state_t *) ) ;
int   PROTO( mawk_space_split, (mawk_state_t *, char *, unsigned) ) ;
int   PROTO( mawk_re_split, (mawk_state_t *, char *, PTR) ) ;
int   PROTO( mawk_null_split, (mawk_state_t *, char *)) ;
void  PROTO( mawk_field_assign, (mawk_state_t *, CELL*, CELL *) ) ;
char *PROTO( mawk_is_string_split, (PTR , unsigned *) ) ;
void  PROTO( mawk_slow_cell_assign, (mawk_state_t *, CELL*, CELL*)) ;
CELL *PROTO( mawk_slow_field_ptr, (mawk_state_t *, int)) ;
int   PROTO( mawk_field_addr_to_index, (mawk_state_t *, CELL*)) ;
void  PROTO( set_binmode, (int)) ;


/* some compilers choke on (NF-field) in a case statement
   even though it's constant so ...
*/
#define  NF_field    (MAX_SPLIT+1)
#define  RS_field    (MAX_SPLIT+2) 
#define  FS_field    (MAX_SPLIT+3) 
#define  CONVFMT_field (MAX_SPLIT+4)
#define  OFMT_field  (MAX_SPLIT+5) 

/* index to CELL *  for a field */
#define field_ptr(i) ((i)<=MAX_SPLIT ? MAWK->field+(i):mawk_slow_field_ptr(MAWK, i))

/* the pseudo fields, assignment has side effects */
#define  NF     (MAWK->field+MAX_SPLIT+1)   /* must be first */
#define  RS     (MAWK->field+MAX_SPLIT+2)
#define  FS     (MAWK->field+MAX_SPLIT+3)
#define  CONVFMT  (MAWK->field+MAX_SPLIT+4)
#define  OFMT   (MAWK->field+MAX_SPLIT+5)   /* must be last */

#define  LAST_PFIELD	OFMT

/* a shadow type for RS and FS */
#define  SEP_SPACE      0
#define  SEP_CHAR       1
#define  SEP_STR        2
#define  SEP_RE         3
#define  SEP_MLR	4

/*  types for splitting mawk_overflow */


#endif   /* FIELD_H  */
