
/********************************************
init.h
copyright 1991, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/

/* $Log: init.h,v $
 * Revision 1.2  1995/06/18  19:42:18  mike
 * Remove some redundant declarations and add some prototypes
 *
 * Revision 1.1.1.1  1993/07/03  18:58:14  mike
 * move source to cvs
 *
 * Revision 5.1  1991/12/05  07:59:22  brennan
 * 1.1 pre-release
 *
*/

/* init.h  */


#ifndef  INIT_H
#define  INIT_H

#include <libmawk/symtype.h>

/* nodes to link file names for multiple
   -f option */

extern char *sprintf_buff, *sprintf_limit ;


mawk_state_t *PROTO( mawk_initialize, (int, char **) ) ;
void PROTO(mawk_uninitialize, (mawk_state_t *m));
void  PROTO( code_init, (mawk_state_t *) ) ;
void  PROTO( code_cleanup, (void) ) ;
void  PROTO( compile_cleanup, (void) ) ;
void PROTO(mawk_scan_init, (mawk_state_t *, char *) ) ;
void PROTO(bi_vars_init, (mawk_state_t *MAWK) ) ;
void PROTO(bi_funct_init, (mawk_state_t *) ) ;
void PROTO(print_init, (void) ) ;
void PROTO(mawk_kw_init, (mawk_state_t *MAWK) ) ;
void  PROTO( mawk_field_init, (mawk_state_t *) ) ;
void  PROTO( mawk_fpe_init, (void) ) ;
void  PROTO( mawk_load_environ, (mawk_state_t *MAWK,ARRAY)) ;
void  PROTO( mawk_set_stderr, (mawk_state_t *MAWK)) ;
void PROTO(mawk_append_input_file, (mawk_state_t *MAWK, const char *fn)) ;

#endif   /* INIT_H  */
