
/********************************************
memory.h
copyright 1991, Michael D. Brennan

This is a source file for mawk, an implementation of
the AWK programming language.

Mawk is distributed without warranty under the terms of
the GNU General Public License, version 2, 1991.
********************************************/


/* $Log: memory.h,v $
 * Revision 1.1.1.1  1993/07/03  18:58:17  mike
 * move source to cvs
 *
 * Revision 5.2  1993/01/01  21:30:48  mike
 * split mawk_new_STRING() into mawk_new_STRING and mawk_new_STRING0
 *
 * Revision 5.1  1991/12/05  07:59:28  brennan
 * 1.1 pre-release
 *
*/


/*  memory.h  */

#ifndef  MEMORY_H
#define  MEMORY_H

#include <libmawk/zmalloc.h>


STRING *PROTO(mawk_new_STRING, (mawk_state_t *, char*)) ;
STRING *PROTO(mawk_new_STRING0, (mawk_state_t *, unsigned)) ;

#ifdef   DEBUG
void  PROTO( DB_free_STRING , (mawk_state_t *, STRING *) ) ;

#define  free_STRING(s)  DB_free_STRING(MAWK, s)

#else

#define  free_STRING(sval)   if ( -- (sval)->ref_cnt == 0 )\
                                zfree(MAWK, sval, (sval)->len+STRING_OH) ; else
#endif

#ifdef	 DEBUG
static void PROTO(eval_overflow, (mawk_state_t *MAWK)) ;

#define	 inc_sp()   if( ++sp == MAWK->eval_stack+EVAL_STACK_SIZE )\
			 eval_overflow(MAWK)
#else

/* If things are working, the eval stack should not mawk_overflow */

#define inc_sp()    sp++
#endif


#endif   /* MEMORY_H */
